#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK44x4x44NN4x4x44_aX_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=44, NB=4, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=4, ku=44, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + 44;
   const double *stN = B + (((ldb) << 2));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 4 - (44*(lda)), incAn = -44;
   #define incBk 44
   const int incBm = -44, incBn = (((ldb) << 2));
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 44;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* M-loop */
   {
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC1_0 = pC0[1];
      rC1_0 *= rA0;
      rC2_0 = pC0[2];
      rC2_0 *= rA0;
      rC3_0 = pC0[3];
      rC3_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC1_1 = pC1[1];
      rC1_1 *= rA0;
      rC2_1 = pC1[2];
      rC2_1 *= rA0;
      rC3_1 = pC1[3];
      rC3_1 *= rA0;
      rC0_2 = *pC2;
      rC0_2 *= rA0;
      rC1_2 = pC2[1];
      rC1_2 *= rA0;
      rC2_2 = pC2[2];
      rC2_2 *= rA0;
      rC3_2 = pC2[3];
      rC3_2 *= rA0;
      rC0_3 = *pC3;
      rC0_3 *= rA0;
      rC1_3 = pC3[1];
      rC1_3 *= rA0;
      rC2_3 = pC3[2];
      rC2_3 *= rA0;
      rC3_3 = pC3[3];
      rC3_3 *= rA0;
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = *pB1;
      rB2 = *pB2;
      rC1_0 += rA1 * rB0;
      rB3 = *pB3;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[1];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[1];
      rB2 = pB2[1];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[1];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[2];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[2];
      rB2 = pB2[2];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[2];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[3];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[3];
      rB2 = pB2[3];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[3];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[4];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[4];
      rB2 = pB2[4];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[4];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[5];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[5];
      rB2 = pB2[5];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[5];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[6];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[6];
      rB2 = pB2[6];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[6];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[7];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[7];
      rB2 = pB2[7];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[7];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[8];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[8];
      rB2 = pB2[8];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[8];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[9];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[9];
      rB2 = pB2[9];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[9];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[10];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[10];
      rB2 = pB2[10];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[10];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[11];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[11];
      rB2 = pB2[11];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[11];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[12];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[12];
      rB2 = pB2[12];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[12];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[13];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[13];
      rB2 = pB2[13];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[13];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[14];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[14];
      rB2 = pB2[14];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[14];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[15];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[15];
      rB2 = pB2[15];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[15];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[16];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[16];
      rB2 = pB2[16];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[16];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[17];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[17];
      rB2 = pB2[17];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[17];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[18];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[18];
      rB2 = pB2[18];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[18];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[19];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[19];
      rB2 = pB2[19];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[19];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[20];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[20];
      rB2 = pB2[20];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[20];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[21];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[21];
      rB2 = pB2[21];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[21];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[22];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[22];
      rB2 = pB2[22];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[22];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[23];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[23];
      rB2 = pB2[23];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[23];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[24];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[24];
      rB2 = pB2[24];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[24];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[25];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[25];
      rB2 = pB2[25];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[25];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[26];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[26];
      rB2 = pB2[26];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[26];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[27];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[27];
      rB2 = pB2[27];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[27];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[28];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[28];
      rB2 = pB2[28];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[28];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[29];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[29];
      rB2 = pB2[29];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[29];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[30];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[30];
      rB2 = pB2[30];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[30];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[31];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[31];
      rB2 = pB2[31];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[31];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[32];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[32];
      rB2 = pB2[32];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[32];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[33];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[33];
      rB2 = pB2[33];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[33];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[34];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[34];
      rB2 = pB2[34];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[34];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[35];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[35];
      rB2 = pB2[35];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[35];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[36];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[36];
      rB2 = pB2[36];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[36];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[37];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[37];
      rB2 = pB2[37];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[37];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[38];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[38];
      rB2 = pB2[38];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[38];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[39];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[39];
      rB2 = pB2[39];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[39];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[40];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[40];
      rB2 = pB2[40];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[40];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[41];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[41];
      rB2 = pB2[41];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[41];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[42];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[42];
      rB2 = pB2[42];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[42];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[43];
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rC0_0 += rA0 * rB0;
      rB1 = pB1[43];
      rB2 = pB2[43];
      rC1_0 += rA1 * rB0;
      rB3 = pB3[43];
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      rC2_3 += rA2 * rB3;
      rC3_3 += rA3 * rB3;
      pA0 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
      pB3 += incBk;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      rC1_2 *= rB0;
      rC1_3 *= rB0;
      rC2_0 *= rB0;
      rC2_1 *= rB0;
      rC2_2 *= rB0;
      rC2_3 *= rB0;
      rC3_0 *= rB0;
      rC3_1 *= rB0;
      rC3_2 *= rB0;
      rC3_3 *= rB0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC3[2] = rC2_3;
      pC3[3] = rC3_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
   }
   while(pA0 != stM);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK44x44x44NN0x0x0_aX_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=44, NB=44, KB=44, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=5, ku=44, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 44;
   const double *stN = B + (((ldb) << 5)+((ldb) << 3));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 4 - (44*(lda)), incAn = -44;
   #define incBk 44
   const int incBm = -44, incBn = (((ldb) << 2)+ldb);
   #define incCm 4
   const int incCn = (((ldc) << 2)+ldc) - 44;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3, rB4;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC3_1 = pC1[3];
         rC3_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC3_2 = pC2[3];
         rC3_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
         rC2_3 = pC3[2];
         rC2_3 *= rA0;
         rC3_3 = pC3[3];
         rC3_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC1_4 = pC4[1];
         rC1_4 *= rA0;
         rC2_4 = pC4[2];
         rC2_4 *= rA0;
         rC3_4 = pC4[3];
         rC3_4 *= rA0;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rC1_0 += rA1 * rB0;
         rB3 = *pB3;
         rB4 = *pB4;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[1];
         rB2 = pB2[1];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[1];
         rB4 = pB4[1];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[2];
         rB4 = pB4[2];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[3];
         rB2 = pB2[3];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[3];
         rB4 = pB4[3];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[4];
         rB2 = pB2[4];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[4];
         rB4 = pB4[4];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[5];
         rB2 = pB2[5];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[5];
         rB4 = pB4[5];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[6];
         rB2 = pB2[6];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[6];
         rB4 = pB4[6];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[7];
         rB2 = pB2[7];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[7];
         rB4 = pB4[7];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[8];
         rB2 = pB2[8];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[8];
         rB4 = pB4[8];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[9];
         rB2 = pB2[9];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[9];
         rB4 = pB4[9];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[10];
         rB2 = pB2[10];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[10];
         rB4 = pB4[10];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[11];
         rB2 = pB2[11];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[11];
         rB4 = pB4[11];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[12];
         rB2 = pB2[12];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[12];
         rB4 = pB4[12];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[13];
         rB2 = pB2[13];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[13];
         rB4 = pB4[13];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[14];
         rB2 = pB2[14];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[14];
         rB4 = pB4[14];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[15];
         rB2 = pB2[15];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[15];
         rB4 = pB4[15];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[16];
         rB2 = pB2[16];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[16];
         rB4 = pB4[16];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[17];
         rB2 = pB2[17];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[17];
         rB4 = pB4[17];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[18];
         rB2 = pB2[18];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[18];
         rB4 = pB4[18];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[19];
         rB2 = pB2[19];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[19];
         rB4 = pB4[19];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[20];
         rB2 = pB2[20];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[20];
         rB4 = pB4[20];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[21];
         rB2 = pB2[21];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[21];
         rB4 = pB4[21];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[22];
         rB2 = pB2[22];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[22];
         rB4 = pB4[22];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[23];
         rB2 = pB2[23];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[23];
         rB4 = pB4[23];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[24];
         rB2 = pB2[24];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[24];
         rB4 = pB4[24];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[25];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[25];
         rB2 = pB2[25];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[25];
         rB4 = pB4[25];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[26];
         rB2 = pB2[26];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[26];
         rB4 = pB4[26];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[27];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[27];
         rB2 = pB2[27];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[27];
         rB4 = pB4[27];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[28];
         rB2 = pB2[28];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[28];
         rB4 = pB4[28];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[29];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[29];
         rB2 = pB2[29];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[29];
         rB4 = pB4[29];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[30];
         rB2 = pB2[30];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[30];
         rB4 = pB4[30];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[31];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[31];
         rB2 = pB2[31];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[31];
         rB4 = pB4[31];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[32];
         rB2 = pB2[32];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[32];
         rB4 = pB4[32];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[33];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[33];
         rB2 = pB2[33];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[33];
         rB4 = pB4[33];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[34];
         rB2 = pB2[34];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[34];
         rB4 = pB4[34];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[35];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[35];
         rB2 = pB2[35];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[35];
         rB4 = pB4[35];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[36];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[36];
         rB2 = pB2[36];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[36];
         rB4 = pB4[36];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[37];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[37];
         rB2 = pB2[37];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[37];
         rB4 = pB4[37];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[38];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[38];
         rB2 = pB2[38];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[38];
         rB4 = pB4[38];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[39];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[39];
         rB2 = pB2[39];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[39];
         rB4 = pB4[39];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[40];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[40];
         rB2 = pB2[40];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[40];
         rB4 = pB4[40];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[41];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[41];
         rB2 = pB2[41];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[41];
         rB4 = pB4[41];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[42];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[42];
         rB2 = pB2[42];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[42];
         rB4 = pB4[42];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[43];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[43];
         rB2 = pB2[43];
         rC1_0 += rA1 * rB0;
         rB3 = pB3[43];
         rB4 = pB4[43];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC2_4 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         rC3_3 *= rB0;
         rC3_4 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         pC4[3] = rC3_4;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK44x4x44NN4x4x44_aX_b1(44, 4, 44, alpha, ca, lda, cb + (((ldb) << 5)+((ldb) << 3)), ldb, beta, cc + (((ldc) << 5)+((ldc) << 3)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
