#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x34TN1x1x6_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=1, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 6
   const int incBm = -34, incBn = 34;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         m1 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         m2 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         m3 = rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         m4 = rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         m5 = rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];

         pA0 += (((incAk0) << 2)+((incAk0) << 1));
         pB0 += (((incBk0) << 2)+((incBk0) << 1));
         for (k=24; k; k -= 6) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m1;
            m1 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m2;
            m2 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m3;
            m3 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m5;
            m5 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += m1;
         m1 = rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         pA0 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rC0_0 += m4;
         rC0_0 += m5;
         rC0_0 += m0;
         rC0_0 += m1;
         rC0_0 += m2;
         rC0_0 += m3;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x0x34TN6x1x6_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=6, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/6)*6;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 170, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 6
   const int incBm = -34, incBn = 34;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 6
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[34];
            rA2 = pA0[68];
            m0 = rA0 * rB0;
            rA3 = pA0[102];
            rA4 = pA0[136];
            rA5 = pA0[170];
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            m3 = rA3 * rB0;
            m4 = rA4 * rB0;
            m5 = rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[35];
            rA2 = pA0[69];
            rA3 = pA0[103];
            rA4 = pA0[137];
            rA5 = pA0[171];

            pA0 += (incAk0);
            pB0 += (incBk0);
            for (k=30; k; k -= 6) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[35];
               rA2 = pA0[69];
               rA3 = pA0[103];
               rA4 = pA0[137];
               rA5 = pA0[171];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[36];
               rA2 = pA0[70];
               rA3 = pA0[104];
               rA4 = pA0[138];
               rA5 = pA0[172];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[37];
               rA2 = pA0[71];
               rA3 = pA0[105];
               rA4 = pA0[139];
               rA5 = pA0[173];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[38];
               rA2 = pA0[72];
               rA3 = pA0[106];
               rA4 = pA0[140];
               rA5 = pA0[174];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[39];
               rA2 = pA0[73];
               rA3 = pA0[107];
               rA4 = pA0[141];
               rA5 = pA0[175];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rC5_0 += m5;
               m5 = rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[40];
               rA2 = pA0[74];
               rA3 = pA0[108];
               rA4 = pA0[142];
               rA5 = pA0[176];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rC4_0 += m4;
            m4 = rA4 * rB0;
            rC5_0 += m5;
            m5 = rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[35];
            rA2 = pA0[69];
            rA3 = pA0[103];
            rA4 = pA0[137];
            rA5 = pA0[171];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rC4_0 += m4;
            m4 = rA4 * rB0;
            rC5_0 += m5;
            m5 = rA5 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[36];
            rA2 = pA0[70];
            rA3 = pA0[104];
            rA4 = pA0[138];
            rA5 = pA0[172];
            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rC4_0 += m4;
            m4 = rA4 * rB0;
            rC5_0 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            rC1_0 += m1;
            rC2_0 += m2;
            rC3_0 += m3;
            rC4_0 += m4;
            rC5_0 += m5;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x34TN1x1x6_a1_bX(k, N, 34, alpha, ca + (((Mb) << 5)+((Mb) << 1)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x34TN1x3x6_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=1, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N/3)*3;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 6
   const int incBm = -34, incBn = 102;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 1
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC0_1, rC0_2;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[34];
            rB2 = pB0[68];
            m0 = rA0 * rB0;
            m1 = rA0 * rB1;
            m2 = rA0 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[35];
            rB2 = pB0[69];
            m3 = rA0 * rB0;
            m4 = rA0 * rB1;
            m5 = rA0 * rB2;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[36];
            rB2 = pB0[70];

            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
            for (k=30; k; k -= 6) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[35];
               rB2 = pB0[69];
               rC0_0 += m3;
               m3 = rA0 * rB0;
               rC0_1 += m4;
               m4 = rA0 * rB1;
               rC0_2 += m5;
               m5 = rA0 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[36];
               rB2 = pB0[70];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[37];
               rB2 = pB0[71];
               rC0_0 += m3;
               m3 = rA0 * rB0;
               rC0_1 += m4;
               m4 = rA0 * rB1;
               rC0_2 += m5;
               m5 = rA0 * rB2;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[38];
               rB2 = pB0[72];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rC0_2 += m2;
               m2 = rA0 * rB2;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[39];
               rB2 = pB0[73];
               rC0_0 += m3;
               m3 = rA0 * rB0;
               rC0_1 += m4;
               m4 = rA0 * rB1;
               rC0_2 += m5;
               m5 = rA0 * rB2;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB0[40];
               rB2 = pB0[74];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[35];
            rB2 = pB0[69];
            pA0 += (incAk0);
            pB0 += (incBk0);
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m3;
            m3 = rA0 * rB0;
            rC0_1 += m4;
            m4 = rA0 * rB1;
            rC0_2 += m5;
            m5 = rA0 * rB2;
            rC0_0 += m0;
            rC0_1 += m1;
            rC0_2 += m2;
            rC0_0 += m3;
            rC0_1 += m4;
            rC0_2 += m5;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x34TN1x1x6_a1_bX(M, k, 34, alpha, ca, lda, cb + (((Nb) << 5)+((Nb) << 1)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x34TN34x34x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=6, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/6)*6;
   const int Nb = (N/3)*3;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 170, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 6
   const int incBm = -34, incBn = 102;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 6
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0, rB1, rB2;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            do /* M-loop */
            {
               ATL_pfl1R(pfA);
               ATL_pfl1R(pfA+ATL_L1LS);
               pfA += incPFA;
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC4_0 = pC0[4];
               rC4_0 *= rA0;
               rC5_0 = pC0[5];
               rC5_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC4_1 = pC1[4];
               rC4_1 *= rA0;
               rC5_1 = pC1[5];
               rC5_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC2_2 = pC2[2];
               rC2_2 *= rA0;
               rC3_2 = pC2[3];
               rC3_2 *= rA0;
               rC4_2 = pC2[4];
               rC4_2 *= rA0;
               rC5_2 = pC2[5];
               rC5_2 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[34];
               rA2 = pA0[68];
               m0 = rA0 * rB0;
               rA3 = pA0[102];
               rA4 = pA0[136];
               rA5 = pA0[170];
               rB1 = pB0[34];
               m1 = rA1 * rB0;
               rB2 = pB0[68];
               m2 = rA2 * rB0;
               m3 = rA3 * rB0;
               m4 = rA4 * rB0;
               m5 = rA5 * rB0;

               for (k=30; k; k -= 6) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA0[35];
                  rA2 = pA0[69];
                  rA3 = pA0[103];
                  rA4 = pA0[137];
                  rA5 = pA0[171];
                  rB1 = pB0[35];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[69];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA0[36];
                  rA2 = pA0[70];
                  rA3 = pA0[104];
                  rA4 = pA0[138];
                  rA5 = pA0[172];
                  rB1 = pB0[36];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[70];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA0[37];
                  rA2 = pA0[71];
                  rA3 = pA0[105];
                  rA4 = pA0[139];
                  rA5 = pA0[173];
                  rB1 = pB0[37];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[71];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA0[38];
                  rA2 = pA0[72];
                  rA3 = pA0[106];
                  rA4 = pA0[140];
                  rA5 = pA0[174];
                  rB1 = pB0[38];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[72];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA0[39];
                  rA2 = pA0[73];
                  rA3 = pA0[107];
                  rA4 = pA0[141];
                  rA5 = pA0[175];
                  rB1 = pB0[39];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[73];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rC5_0 += m5;
                  m5 = rA5 * rB1;
                  rC0_1 += m0;
                  m0 = rA0 * rB2;
                  rC1_1 += m1;
                  m1 = rA1 * rB2;
                  rC2_1 += m2;
                  m2 = rA2 * rB2;
                  rC3_1 += m3;
                  m3 = rA3 * rB2;
                  rC4_1 += m4;
                  m4 = rA4 * rB2;
                  rC5_1 += m5;
                  m5 = rA5 * rB2;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA0[40];
                  rA2 = pA0[74];
                  rA3 = pA0[108];
                  rA4 = pA0[142];
                  rA5 = pA0[176];
                  rB1 = pB0[40];
                  rC0_2 += m0;
                  m0 = rA0 * rB0;
                  rB2 = pB0[74];
                  rC1_2 += m1;
                  m1 = rA1 * rB0;
                  rC2_2 += m2;
                  m2 = rA2 * rB0;
                  rC3_2 += m3;
                  m3 = rA3 * rB0;
                  rC4_2 += m4;
                  m4 = rA4 * rB0;
                  rC5_2 += m5;
                  m5 = rA5 * rB0;
                  pA0 += incAk;
                  pB0 += incBk;
               } /* end K-loop */
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[35];
               rA2 = pA0[69];
               rA3 = pA0[103];
               rA4 = pA0[137];
               rA5 = pA0[171];
               rB1 = pB0[35];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[69];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[36];
               rA2 = pA0[70];
               rA3 = pA0[104];
               rA4 = pA0[138];
               rA5 = pA0[172];
               rB1 = pB0[36];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[70];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[37];
               rA2 = pA0[71];
               rA3 = pA0[105];
               rA4 = pA0[139];
               rA5 = pA0[173];
               rB1 = pB0[37];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[71];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               pA0 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rC0_2 += m0;
               rC1_2 += m1;
               rC2_2 += m2;
               rC3_2 += m3;
               rC4_2 += m4;
               rC5_2 += m5;
               pA0 += incAk0;
               pB0 += incBk0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               pC0[4] = rC4_0;
               pC0[5] = rC5_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC1[4] = rC4_1;
               pC1[5] = rC5_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               pC2[2] = rC2_2;
               pC2[3] = rC3_2;
               pC2[4] = rC4_2;
               pC2[5] = rC5_2;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_dJIK0x0x34TN6x1x6_a1_bX(M, k, 34, alpha, ca, lda, cb + (((Nb) << 5)+((Nb) << 1)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_dJIK0x0x34TN1x3x6_a1_bX(k, Nb, 34, alpha, ca + (((Mb) << 5)+((Mb) << 1)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
