#ifdef ATL_UCLEANM
#define ATL_dJIK0x48x48TN48x48x0_a1_bX ATL_dgpMBmm_bX
#else
#define ATL_dJIK0x48x48TN48x48x0_a1_bX ATL_dpMBmm_bX
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x48x48TN1x3x6_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2304;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 6
   const int incBm = -48, incBn = 144;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 1
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC0_1, rC0_2;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[48];
         rB2 = pB0[96];
         m0 = rA0 * rB0;
         m1 = rA0 * rB1;
         m2 = rA0 * rB2;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[49];
         rB2 = pB0[97];
         m3 = rA0 * rB0;
         m4 = rA0 * rB1;
         m5 = rA0 * rB2;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[50];
         rB2 = pB0[98];

         pA0 += (((incAk0) << 1));
         pB0 += (((incBk0) << 1));
         for (k=42; k; k -= 6) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[49];
            rB2 = pB0[97];
            rC0_0 += m3;
            m3 = rA0 * rB0;
            rC0_1 += m4;
            m4 = rA0 * rB1;
            rC0_2 += m5;
            m5 = rA0 * rB2;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[50];
            rB2 = pB0[98];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rB1 = pB0[51];
            rB2 = pB0[99];
            rC0_0 += m3;
            m3 = rA0 * rB0;
            rC0_1 += m4;
            m4 = rA0 * rB1;
            rC0_2 += m5;
            m5 = rA0 * rB2;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB0[52];
            rB2 = pB0[100];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_2 += m2;
            m2 = rA0 * rB2;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rB1 = pB0[53];
            rB2 = pB0[101];
            rC0_0 += m3;
            m3 = rA0 * rB0;
            rC0_1 += m4;
            m4 = rA0 * rB1;
            rC0_2 += m5;
            m5 = rA0 * rB2;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rB1 = pB0[54];
            rB2 = pB0[102];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[49];
         rB2 = pB0[97];
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rC0_1 += m4;
         m4 = rA0 * rB1;
         rC0_2 += m5;
         m5 = rA0 * rB2;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[50];
         rB2 = pB0[98];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[51];
         rB2 = pB0[99];
         pA0 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m3;
         m3 = rA0 * rB0;
         rC0_1 += m4;
         m4 = rA0 * rB1;
         rC0_2 += m5;
         m5 = rA0 * rB2;
         rC0_0 += m0;
         rC0_1 += m1;
         rC0_2 += m2;
         rC0_0 += m3;
         rC0_1 += m4;
         rC0_2 += m5;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x48x48TN48x48x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=6, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/6)*6;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2304;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 240, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 6
   const int incBm = -48, incBn = 144;
   const int incAk0 = ((incAk) / 6), incBk0 = ((incBk) / 6);
   #define incCm 6
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0, rB1, rB2;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[1];
            rC1_1 *= rA0;
            rC2_1 = pC1[2];
            rC2_1 *= rA0;
            rC3_1 = pC1[3];
            rC3_1 *= rA0;
            rC4_1 = pC1[4];
            rC4_1 *= rA0;
            rC5_1 = pC1[5];
            rC5_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC1_2 = pC2[1];
            rC1_2 *= rA0;
            rC2_2 = pC2[2];
            rC2_2 *= rA0;
            rC3_2 = pC2[3];
            rC3_2 *= rA0;
            rC4_2 = pC2[4];
            rC4_2 *= rA0;
            rC5_2 = pC2[5];
            rC5_2 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            rA2 = pA0[96];
            m0 = rA0 * rB0;
            rA3 = pA0[144];
            rA4 = pA0[192];
            rA5 = pA0[240];
            rB1 = pB0[48];
            m1 = rA1 * rB0;
            rB2 = pB0[96];
            m2 = rA2 * rB0;
            m3 = rA3 * rB0;
            m4 = rA4 * rB0;
            m5 = rA5 * rB0;

            for (k=42; k; k -= 6) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[49];
               rA2 = pA0[97];
               rA3 = pA0[145];
               rA4 = pA0[193];
               rA5 = pA0[241];
               rB1 = pB0[49];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[97];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[50];
               rA2 = pA0[98];
               rA3 = pA0[146];
               rA4 = pA0[194];
               rA5 = pA0[242];
               rB1 = pB0[50];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[98];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[51];
               rA2 = pA0[99];
               rA3 = pA0[147];
               rA4 = pA0[195];
               rA5 = pA0[243];
               rB1 = pB0[51];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[99];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[52];
               rA2 = pA0[100];
               rA3 = pA0[148];
               rA4 = pA0[196];
               rA5 = pA0[244];
               rB1 = pB0[52];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[100];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[53];
               rA2 = pA0[101];
               rA3 = pA0[149];
               rA4 = pA0[197];
               rA5 = pA0[245];
               rB1 = pB0[53];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[101];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC5_0 += m5;
               m5 = rA5 * rB1;
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rC1_1 += m1;
               m1 = rA1 * rB2;
               rC2_1 += m2;
               m2 = rA2 * rB2;
               rC3_1 += m3;
               m3 = rA3 * rB2;
               rC4_1 += m4;
               m4 = rA4 * rB2;
               rC5_1 += m5;
               m5 = rA5 * rB2;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[54];
               rA2 = pA0[102];
               rA3 = pA0[150];
               rA4 = pA0[198];
               rA5 = pA0[246];
               rB1 = pB0[54];
               rC0_2 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[102];
               rC1_2 += m1;
               m1 = rA1 * rB0;
               rC2_2 += m2;
               m2 = rA2 * rB0;
               rC3_2 += m3;
               m3 = rA3 * rB0;
               rC4_2 += m4;
               m4 = rA4 * rB0;
               rC5_2 += m5;
               m5 = rA5 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[49];
            rA2 = pA0[97];
            rA3 = pA0[145];
            rA4 = pA0[193];
            rA5 = pA0[241];
            rB1 = pB0[49];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[97];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC3_2 += m3;
            m3 = rA3 * rB0;
            rC4_2 += m4;
            m4 = rA4 * rB0;
            rC5_2 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[50];
            rA2 = pA0[98];
            rA3 = pA0[146];
            rA4 = pA0[194];
            rA5 = pA0[242];
            rB1 = pB0[50];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[98];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC3_2 += m3;
            m3 = rA3 * rB0;
            rC4_2 += m4;
            m4 = rA4 * rB0;
            rC5_2 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[51];
            rA2 = pA0[99];
            rA3 = pA0[147];
            rA4 = pA0[195];
            rA5 = pA0[243];
            rB1 = pB0[51];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[99];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC3_2 += m3;
            m3 = rA3 * rB0;
            rC4_2 += m4;
            m4 = rA4 * rB0;
            rC5_2 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[52];
            rA2 = pA0[100];
            rA3 = pA0[148];
            rA4 = pA0[196];
            rA5 = pA0[244];
            rB1 = pB0[52];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[100];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC3_2 += m3;
            m3 = rA3 * rB0;
            rC4_2 += m4;
            m4 = rA4 * rB0;
            rC5_2 += m5;
            m5 = rA5 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[53];
            rA2 = pA0[101];
            rA3 = pA0[149];
            rA4 = pA0[197];
            rA5 = pA0[245];
            rB1 = pB0[53];
            rC0_2 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[101];
            rC1_2 += m1;
            m1 = rA1 * rB0;
            rC2_2 += m2;
            m2 = rA2 * rB0;
            rC3_2 += m3;
            m3 = rA3 * rB0;
            rC4_2 += m4;
            m4 = rA4 * rB0;
            rC5_2 += m5;
            m5 = rA5 * rB0;
            pA0 += (((incAk0) << 2)+incAk0);
            pB0 += (((incBk0) << 2)+incBk0);
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            rC5_0 += m5;
            m5 = rA5 * rB1;
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC1_1 += m1;
            m1 = rA1 * rB2;
            rC2_1 += m2;
            m2 = rA2 * rB2;
            rC3_1 += m3;
            m3 = rA3 * rB2;
            rC4_1 += m4;
            m4 = rA4 * rB2;
            rC5_1 += m5;
            m5 = rA5 * rB2;
            rC0_2 += m0;
            rC1_2 += m1;
            rC2_2 += m2;
            rC3_2 += m3;
            rC4_2 += m4;
            rC5_2 += m5;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            pC1[4] = rC4_1;
            pC1[5] = rC5_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            pC2[4] = rC4_2;
            pC2[5] = rC5_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x48x48TN1x3x6_a1_bX(k, 48, 48, alpha, ca + (((Mb) << 5)+((Mb) << 4)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
