#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK48x0x48TN4x1x8_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=0, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=4, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *stM = A + 2304;
   const double *stN = B + (((Nb) << 5)+((Nb) << 4));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(48*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 144, incAn = -2304;
   #define incBk 8
   const int incBm = -48, incBn = 48;
   const int incAk0 = ((incAk) >> 3), incBk0 = ((incBk) >> 3);
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 96;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[48];
         rA2 = pA0[96];
         m0 = rA0 * rB0;
         rA3 = pA0[144];
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[49];
         rA2 = pA0[97];
         rA3 = pA0[145];
         m4 = rA0 * rB0;
         m5 = rA1 * rB0;
         m6 = rA2 * rB0;
         m7 = rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[50];
         rA2 = pA0[98];
         rA3 = pA0[146];

         pA0 += (((incAk0) << 1));
         pB0 += (((incBk0) << 1));
         for (k=40; k; k -= 8) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[49];
            rA2 = pA0[97];
            rA3 = pA0[145];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[50];
            rA2 = pA0[98];
            rA3 = pA0[146];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[51];
            rA2 = pA0[99];
            rA3 = pA0[147];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[52];
            rA2 = pA0[100];
            rA3 = pA0[148];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[53];
            rA2 = pA0[101];
            rA3 = pA0[149];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[54];
            rA2 = pA0[102];
            rA3 = pA0[150];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[55];
            rA2 = pA0[103];
            rA3 = pA0[151];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[56];
            rA2 = pA0[104];
            rA3 = pA0[152];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[49];
         rA2 = pA0[97];
         rA3 = pA0[145];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[50];
         rA2 = pA0[98];
         rA3 = pA0[146];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[51];
         rA2 = pA0[99];
         rA3 = pA0[147];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[52];
         rA2 = pA0[100];
         rA3 = pA0[148];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[53];
         rA2 = pA0[101];
         rA3 = pA0[149];
         pA0 += (((incAk0) << 2)+incAk0);
         pB0 += (((incBk0) << 2)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         rC0_0 += m0;
         rC1_0 += m1;
         rC2_0 += m2;
         rC3_0 += m3;
         rC0_0 += m4;
         rC1_0 += m5;
         rC2_0 += m6;
         rC3_0 += m7;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK48x0x48TN48x48x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=0, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=4, nu=5, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/5)*5;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 2304;
   const double *stN = B + (((Nb) << 5)+((Nb) << 4));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*5)/(48*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 144, incAn = -2304;
   #define incBk 8
   const int incBm = -48, incBn = 240;
   const int incAk0 = ((incAk) >> 3), incBk0 = ((incBk) >> 3);
   #define incCm 8
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - 96;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3, rB4;
   register double m0, m1, m2, m3, m4, m5, m6, m7;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[2];
            rC1_1 *= rA0;
            rC2_1 = pC1[4];
            rC2_1 *= rA0;
            rC3_1 = pC1[6];
            rC3_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC1_2 = pC2[2];
            rC1_2 *= rA0;
            rC2_2 = pC2[4];
            rC2_2 *= rA0;
            rC3_2 = pC2[6];
            rC3_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC1_3 = pC3[2];
            rC1_3 *= rA0;
            rC2_3 = pC3[4];
            rC2_3 *= rA0;
            rC3_3 = pC3[6];
            rC3_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC1_4 = pC4[2];
            rC1_4 *= rA0;
            rC2_4 = pC4[4];
            rC2_4 *= rA0;
            rC3_4 = pC4[6];
            rC3_4 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            rA2 = pA0[96];
            m0 = rA0 * rB0;
            rA3 = pA0[144];
            rB1 = pB0[48];
            m1 = rA1 * rB0;
            rB2 = pB0[96];
            rB3 = pB0[144];
            m2 = rA2 * rB0;
            rB4 = pB0[192];
            m3 = rA3 * rB0;
            m4 = rA0 * rB1;
            m5 = rA1 * rB1;
            m6 = rA2 * rB1;
            m7 = rA3 * rB1;

            for (k=40; k; k -= 8) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC1_0 += m1;
               m1 = rA1 * rB2;
               rC2_0 += m2;
               m2 = rA2 * rB2;
               rC3_0 += m3;
               m3 = rA3 * rB2;
               rC0_1 += m4;
               m4 = rA0 * rB3;
               rC1_1 += m5;
               m5 = rA1 * rB3;
               rC2_1 += m6;
               m6 = rA2 * rB3;
               rC3_1 += m7;
               m7 = rA3 * rB3;
               rC0_2 += m0;
               m0 = rA0 * rB4;
               rC1_2 += m1;
               m1 = rA1 * rB4;
               rC2_2 += m2;
               m2 = rA2 * rB4;
               rC3_2 += m3;
               m3 = rA3 * rB4;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[49];
               rA2 = pA0[97];
               rA3 = pA0[145];
               rB1 = pB0[49];
               rC0_3 += m4;
               m4 = rA0 * rB0;
               rB2 = pB0[97];
               rB3 = pB0[145];
               rC1_3 += m5;
               m5 = rA1 * rB0;
               rB4 = pB0[193];
               rC2_3 += m6;
               m6 = rA2 * rB0;
               rC3_3 += m7;
               m7 = rA3 * rB0;
               rC0_4 += m0;
               m0 = rA0 * rB1;
               rC1_4 += m1;
               m1 = rA1 * rB1;
               rC2_4 += m2;
               m2 = rA2 * rB1;
               rC3_4 += m3;
               m3 = rA3 * rB1;
               rC0_0 += m4;
               m4 = rA0 * rB2;
               rC1_0 += m5;
               m5 = rA1 * rB2;
               rC2_0 += m6;
               m6 = rA2 * rB2;
               rC3_0 += m7;
               m7 = rA3 * rB2;
               rC0_1 += m0;
               m0 = rA0 * rB3;
               rC1_1 += m1;
               m1 = rA1 * rB3;
               rC2_1 += m2;
               m2 = rA2 * rB3;
               rC3_1 += m3;
               m3 = rA3 * rB3;
               rC0_2 += m4;
               m4 = rA0 * rB4;
               rC1_2 += m5;
               m5 = rA1 * rB4;
               rC2_2 += m6;
               m6 = rA2 * rB4;
               rC3_2 += m7;
               m7 = rA3 * rB4;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[50];
               rA2 = pA0[98];
               rA3 = pA0[146];
               rB1 = pB0[50];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[98];
               rB3 = pB0[146];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB4 = pB0[194];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC1_0 += m1;
               m1 = rA1 * rB2;
               rC2_0 += m2;
               m2 = rA2 * rB2;
               rC3_0 += m3;
               m3 = rA3 * rB2;
               rC0_1 += m4;
               m4 = rA0 * rB3;
               rC1_1 += m5;
               m5 = rA1 * rB3;
               rC2_1 += m6;
               m6 = rA2 * rB3;
               rC3_1 += m7;
               m7 = rA3 * rB3;
               rC0_2 += m0;
               m0 = rA0 * rB4;
               rC1_2 += m1;
               m1 = rA1 * rB4;
               rC2_2 += m2;
               m2 = rA2 * rB4;
               rC3_2 += m3;
               m3 = rA3 * rB4;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[51];
               rA2 = pA0[99];
               rA3 = pA0[147];
               rB1 = pB0[51];
               rC0_3 += m4;
               m4 = rA0 * rB0;
               rB2 = pB0[99];
               rB3 = pB0[147];
               rC1_3 += m5;
               m5 = rA1 * rB0;
               rB4 = pB0[195];
               rC2_3 += m6;
               m6 = rA2 * rB0;
               rC3_3 += m7;
               m7 = rA3 * rB0;
               rC0_4 += m0;
               m0 = rA0 * rB1;
               rC1_4 += m1;
               m1 = rA1 * rB1;
               rC2_4 += m2;
               m2 = rA2 * rB1;
               rC3_4 += m3;
               m3 = rA3 * rB1;
               rC0_0 += m4;
               m4 = rA0 * rB2;
               rC1_0 += m5;
               m5 = rA1 * rB2;
               rC2_0 += m6;
               m6 = rA2 * rB2;
               rC3_0 += m7;
               m7 = rA3 * rB2;
               rC0_1 += m0;
               m0 = rA0 * rB3;
               rC1_1 += m1;
               m1 = rA1 * rB3;
               rC2_1 += m2;
               m2 = rA2 * rB3;
               rC3_1 += m3;
               m3 = rA3 * rB3;
               rC0_2 += m4;
               m4 = rA0 * rB4;
               rC1_2 += m5;
               m5 = rA1 * rB4;
               rC2_2 += m6;
               m6 = rA2 * rB4;
               rC3_2 += m7;
               m7 = rA3 * rB4;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[52];
               rA2 = pA0[100];
               rA3 = pA0[148];
               rB1 = pB0[52];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[100];
               rB3 = pB0[148];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB4 = pB0[196];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC1_0 += m1;
               m1 = rA1 * rB2;
               rC2_0 += m2;
               m2 = rA2 * rB2;
               rC3_0 += m3;
               m3 = rA3 * rB2;
               rC0_1 += m4;
               m4 = rA0 * rB3;
               rC1_1 += m5;
               m5 = rA1 * rB3;
               rC2_1 += m6;
               m6 = rA2 * rB3;
               rC3_1 += m7;
               m7 = rA3 * rB3;
               rC0_2 += m0;
               m0 = rA0 * rB4;
               rC1_2 += m1;
               m1 = rA1 * rB4;
               rC2_2 += m2;
               m2 = rA2 * rB4;
               rC3_2 += m3;
               m3 = rA3 * rB4;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[53];
               rA2 = pA0[101];
               rA3 = pA0[149];
               rB1 = pB0[53];
               rC0_3 += m4;
               m4 = rA0 * rB0;
               rB2 = pB0[101];
               rB3 = pB0[149];
               rC1_3 += m5;
               m5 = rA1 * rB0;
               rB4 = pB0[197];
               rC2_3 += m6;
               m6 = rA2 * rB0;
               rC3_3 += m7;
               m7 = rA3 * rB0;
               rC0_4 += m0;
               m0 = rA0 * rB1;
               rC1_4 += m1;
               m1 = rA1 * rB1;
               rC2_4 += m2;
               m2 = rA2 * rB1;
               rC3_4 += m3;
               m3 = rA3 * rB1;
               rC0_0 += m4;
               m4 = rA0 * rB2;
               rC1_0 += m5;
               m5 = rA1 * rB2;
               rC2_0 += m6;
               m6 = rA2 * rB2;
               rC3_0 += m7;
               m7 = rA3 * rB2;
               rC0_1 += m0;
               m0 = rA0 * rB3;
               rC1_1 += m1;
               m1 = rA1 * rB3;
               rC2_1 += m2;
               m2 = rA2 * rB3;
               rC3_1 += m3;
               m3 = rA3 * rB3;
               rC0_2 += m4;
               m4 = rA0 * rB4;
               rC1_2 += m5;
               m5 = rA1 * rB4;
               rC2_2 += m6;
               m6 = rA2 * rB4;
               rC3_2 += m7;
               m7 = rA3 * rB4;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[54];
               rA2 = pA0[102];
               rA3 = pA0[150];
               rB1 = pB0[54];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[102];
               rB3 = pB0[150];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB4 = pB0[198];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_0 += m0;
               m0 = rA0 * rB2;
               rC1_0 += m1;
               m1 = rA1 * rB2;
               rC2_0 += m2;
               m2 = rA2 * rB2;
               rC3_0 += m3;
               m3 = rA3 * rB2;
               rC0_1 += m4;
               m4 = rA0 * rB3;
               rC1_1 += m5;
               m5 = rA1 * rB3;
               rC2_1 += m6;
               m6 = rA2 * rB3;
               rC3_1 += m7;
               m7 = rA3 * rB3;
               rC0_2 += m0;
               m0 = rA0 * rB4;
               rC1_2 += m1;
               m1 = rA1 * rB4;
               rC2_2 += m2;
               m2 = rA2 * rB4;
               rC3_2 += m3;
               m3 = rA3 * rB4;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[55];
               rA2 = pA0[103];
               rA3 = pA0[151];
               rB1 = pB0[55];
               rC0_3 += m4;
               m4 = rA0 * rB0;
               rB2 = pB0[103];
               rB3 = pB0[151];
               rC1_3 += m5;
               m5 = rA1 * rB0;
               rB4 = pB0[199];
               rC2_3 += m6;
               m6 = rA2 * rB0;
               rC3_3 += m7;
               m7 = rA3 * rB0;
               rC0_4 += m0;
               m0 = rA0 * rB1;
               rC1_4 += m1;
               m1 = rA1 * rB1;
               rC2_4 += m2;
               m2 = rA2 * rB1;
               rC3_4 += m3;
               m3 = rA3 * rB1;
               rC0_0 += m4;
               m4 = rA0 * rB2;
               rC1_0 += m5;
               m5 = rA1 * rB2;
               rC2_0 += m6;
               m6 = rA2 * rB2;
               rC3_0 += m7;
               m7 = rA3 * rB2;
               rC0_1 += m0;
               m0 = rA0 * rB3;
               rC1_1 += m1;
               m1 = rA1 * rB3;
               rC2_1 += m2;
               m2 = rA2 * rB3;
               rC3_1 += m3;
               m3 = rA3 * rB3;
               rC0_2 += m4;
               m4 = rA0 * rB4;
               rC1_2 += m5;
               m5 = rA1 * rB4;
               rC2_2 += m6;
               m6 = rA2 * rB4;
               rC3_2 += m7;
               m7 = rA3 * rB4;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA0[56];
               rA2 = pA0[104];
               rA3 = pA0[152];
               rB1 = pB0[56];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB2 = pB0[104];
               rB3 = pB0[152];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB4 = pB0[200];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC3_0 += m3;
            m3 = rA3 * rB2;
            rC0_1 += m4;
            m4 = rA0 * rB3;
            rC1_1 += m5;
            m5 = rA1 * rB3;
            rC2_1 += m6;
            m6 = rA2 * rB3;
            rC3_1 += m7;
            m7 = rA3 * rB3;
            rC0_2 += m0;
            m0 = rA0 * rB4;
            rC1_2 += m1;
            m1 = rA1 * rB4;
            rC2_2 += m2;
            m2 = rA2 * rB4;
            rC3_2 += m3;
            m3 = rA3 * rB4;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[49];
            rA2 = pA0[97];
            rA3 = pA0[145];
            rB1 = pB0[49];
            rC0_3 += m4;
            m4 = rA0 * rB0;
            rB2 = pB0[97];
            rB3 = pB0[145];
            rC1_3 += m5;
            m5 = rA1 * rB0;
            rB4 = pB0[193];
            rC2_3 += m6;
            m6 = rA2 * rB0;
            rC3_3 += m7;
            m7 = rA3 * rB0;
            rC0_4 += m0;
            m0 = rA0 * rB1;
            rC1_4 += m1;
            m1 = rA1 * rB1;
            rC2_4 += m2;
            m2 = rA2 * rB1;
            rC3_4 += m3;
            m3 = rA3 * rB1;
            rC0_0 += m4;
            m4 = rA0 * rB2;
            rC1_0 += m5;
            m5 = rA1 * rB2;
            rC2_0 += m6;
            m6 = rA2 * rB2;
            rC3_0 += m7;
            m7 = rA3 * rB2;
            rC0_1 += m0;
            m0 = rA0 * rB3;
            rC1_1 += m1;
            m1 = rA1 * rB3;
            rC2_1 += m2;
            m2 = rA2 * rB3;
            rC3_1 += m3;
            m3 = rA3 * rB3;
            rC0_2 += m4;
            m4 = rA0 * rB4;
            rC1_2 += m5;
            m5 = rA1 * rB4;
            rC2_2 += m6;
            m6 = rA2 * rB4;
            rC3_2 += m7;
            m7 = rA3 * rB4;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[50];
            rA2 = pA0[98];
            rA3 = pA0[146];
            rB1 = pB0[50];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[98];
            rB3 = pB0[146];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB4 = pB0[194];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC3_0 += m3;
            m3 = rA3 * rB2;
            rC0_1 += m4;
            m4 = rA0 * rB3;
            rC1_1 += m5;
            m5 = rA1 * rB3;
            rC2_1 += m6;
            m6 = rA2 * rB3;
            rC3_1 += m7;
            m7 = rA3 * rB3;
            rC0_2 += m0;
            m0 = rA0 * rB4;
            rC1_2 += m1;
            m1 = rA1 * rB4;
            rC2_2 += m2;
            m2 = rA2 * rB4;
            rC3_2 += m3;
            m3 = rA3 * rB4;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[51];
            rA2 = pA0[99];
            rA3 = pA0[147];
            rB1 = pB0[51];
            rC0_3 += m4;
            m4 = rA0 * rB0;
            rB2 = pB0[99];
            rB3 = pB0[147];
            rC1_3 += m5;
            m5 = rA1 * rB0;
            rB4 = pB0[195];
            rC2_3 += m6;
            m6 = rA2 * rB0;
            rC3_3 += m7;
            m7 = rA3 * rB0;
            rC0_4 += m0;
            m0 = rA0 * rB1;
            rC1_4 += m1;
            m1 = rA1 * rB1;
            rC2_4 += m2;
            m2 = rA2 * rB1;
            rC3_4 += m3;
            m3 = rA3 * rB1;
            rC0_0 += m4;
            m4 = rA0 * rB2;
            rC1_0 += m5;
            m5 = rA1 * rB2;
            rC2_0 += m6;
            m6 = rA2 * rB2;
            rC3_0 += m7;
            m7 = rA3 * rB2;
            rC0_1 += m0;
            m0 = rA0 * rB3;
            rC1_1 += m1;
            m1 = rA1 * rB3;
            rC2_1 += m2;
            m2 = rA2 * rB3;
            rC3_1 += m3;
            m3 = rA3 * rB3;
            rC0_2 += m4;
            m4 = rA0 * rB4;
            rC1_2 += m5;
            m5 = rA1 * rB4;
            rC2_2 += m6;
            m6 = rA2 * rB4;
            rC3_2 += m7;
            m7 = rA3 * rB4;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[52];
            rA2 = pA0[100];
            rA3 = pA0[148];
            rB1 = pB0[52];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[100];
            rB3 = pB0[148];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB4 = pB0[196];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC3_0 += m3;
            m3 = rA3 * rB2;
            rC0_1 += m4;
            m4 = rA0 * rB3;
            rC1_1 += m5;
            m5 = rA1 * rB3;
            rC2_1 += m6;
            m6 = rA2 * rB3;
            rC3_1 += m7;
            m7 = rA3 * rB3;
            rC0_2 += m0;
            m0 = rA0 * rB4;
            rC1_2 += m1;
            m1 = rA1 * rB4;
            rC2_2 += m2;
            m2 = rA2 * rB4;
            rC3_2 += m3;
            m3 = rA3 * rB4;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[53];
            rA2 = pA0[101];
            rA3 = pA0[149];
            rB1 = pB0[53];
            rC0_3 += m4;
            m4 = rA0 * rB0;
            rB2 = pB0[101];
            rB3 = pB0[149];
            rC1_3 += m5;
            m5 = rA1 * rB0;
            rB4 = pB0[197];
            rC2_3 += m6;
            m6 = rA2 * rB0;
            rC3_3 += m7;
            m7 = rA3 * rB0;
            rC0_4 += m0;
            m0 = rA0 * rB1;
            rC1_4 += m1;
            m1 = rA1 * rB1;
            rC2_4 += m2;
            m2 = rA2 * rB1;
            rC3_4 += m3;
            m3 = rA3 * rB1;
            rC0_0 += m4;
            m4 = rA0 * rB2;
            rC1_0 += m5;
            m5 = rA1 * rB2;
            rC2_0 += m6;
            m6 = rA2 * rB2;
            rC3_0 += m7;
            m7 = rA3 * rB2;
            rC0_1 += m0;
            m0 = rA0 * rB3;
            rC1_1 += m1;
            m1 = rA1 * rB3;
            rC2_1 += m2;
            m2 = rA2 * rB3;
            rC3_1 += m3;
            m3 = rA3 * rB3;
            rC0_2 += m4;
            m4 = rA0 * rB4;
            rC1_2 += m5;
            m5 = rA1 * rB4;
            rC2_2 += m6;
            m6 = rA2 * rB4;
            rC3_2 += m7;
            m7 = rA3 * rB4;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[54];
            rA2 = pA0[102];
            rA3 = pA0[150];
            rB1 = pB0[54];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB2 = pB0[102];
            rB3 = pB0[150];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB4 = pB0[198];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_0 += m0;
            m0 = rA0 * rB2;
            rC1_0 += m1;
            m1 = rA1 * rB2;
            rC2_0 += m2;
            m2 = rA2 * rB2;
            rC3_0 += m3;
            m3 = rA3 * rB2;
            rC0_1 += m4;
            m4 = rA0 * rB3;
            rC1_1 += m5;
            m5 = rA1 * rB3;
            rC2_1 += m6;
            m6 = rA2 * rB3;
            rC3_1 += m7;
            m7 = rA3 * rB3;
            rC0_2 += m0;
            m0 = rA0 * rB4;
            rC1_2 += m1;
            m1 = rA1 * rB4;
            rC2_2 += m2;
            m2 = rA2 * rB4;
            rC3_2 += m3;
            m3 = rA3 * rB4;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[55];
            rA2 = pA0[103];
            rA3 = pA0[151];
            rB1 = pB0[55];
            rC0_3 += m4;
            m4 = rA0 * rB0;
            rB2 = pB0[103];
            rB3 = pB0[151];
            rC1_3 += m5;
            m5 = rA1 * rB0;
            rB4 = pB0[199];
            rC2_3 += m6;
            m6 = rA2 * rB0;
            rC3_3 += m7;
            m7 = rA3 * rB0;
            rC0_4 += m0;
            m0 = rA0 * rB1;
            rC1_4 += m1;
            m1 = rA1 * rB1;
            rC2_4 += m2;
            m2 = rA2 * rB1;
            rC3_4 += m3;
            m3 = rA3 * rB1;
            pA0 += (7*(incAk0));
            pB0 += (7*(incBk0));
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m4;
            m4 = rA0 * rB2;
            rC1_0 += m5;
            m5 = rA1 * rB2;
            rC2_0 += m6;
            m6 = rA2 * rB2;
            rC3_0 += m7;
            m7 = rA3 * rB2;
            rC0_1 += m0;
            m0 = rA0 * rB3;
            rC1_1 += m1;
            m1 = rA1 * rB3;
            rC2_1 += m2;
            m2 = rA2 * rB3;
            rC3_1 += m3;
            m3 = rA3 * rB3;
            rC0_2 += m4;
            m4 = rA0 * rB4;
            rC1_2 += m5;
            m5 = rA1 * rB4;
            rC2_2 += m6;
            m6 = rA2 * rB4;
            rC3_2 += m7;
            m7 = rA3 * rB4;
            rC0_3 += m0;
            rC1_3 += m1;
            rC2_3 += m2;
            rC3_3 += m3;
            rC0_4 += m4;
            rC1_4 += m5;
            rC2_4 += m6;
            rC3_4 += m7;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC3[4] = rC2_3;
            pC3[6] = rC3_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC4[4] = rC2_4;
            pC4[6] = rC3_4;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_zJIK48x0x48TN4x1x8_a1_bX(48, k, 48, alpha, ca, lda, cb + (((Nb) << 5)+((Nb) << 4)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_bX ATL_zgpNBmm_bX
#endif

void ATL_zJIK48x0x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK48x0x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK48x0x48TN48x48x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
